## mingw-w64-xmlf90-1.6.3-1.src.tar.zst

=== CMakeLists.txt ===

cmake_minimum_required(VERSION 3.14)

project(
  "xmlf90"
  LANGUAGES "Fortran"
  VERSION "1.6.3"
  DESCRIPTION "Lightweight XML parser in fortran"
)

# Follow GNU conventions for installing directories
include(GNUInstallDirs)

# General configuration information
add_subdirectory("config/cmake")

## Let xmlf90_SHARED_LIBS override BUILD_SHARED_LIBS

if (DEFINED ${PROJECT_NAME}_SHARED_LIBS)
    set(BUILD_SHARED_LIBS "${${PROJECT_NAME}_SHARED_LIBS}")
endif ()

# Collect source of the project
set(srcs)
add_subdirectory("src")

add_library(
  "${PROJECT_NAME}-lib"
  "${srcs}"
)

#-------------
#  This is a record of a feature that can be checked programmatically when
#  configuring clients if xmlf90 is used as a pre-compiled library, but
#  not if the xmlf90 source is compiled by the client.
#
set(XMLF90_PARSE_HAS_STAT TRUE CACHE BOOL "xml_parse has 'stat' optional argument")
#-------------

set_target_properties(
  "${PROJECT_NAME}-lib"
  PROPERTIES
  POSITION_INDEPENDENT_CODE TRUE
  OUTPUT_NAME "${PROJECT_NAME}"
  VERSION "${PROJECT_VERSION}"
  SOVERSION "${PROJECT_VERSION_MAJOR}"
  Fortran_MODULE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/include"
)
target_include_directories(
  "${PROJECT_NAME}-lib"
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${module-dir}>
)

# Export targets for other projects
add_library("${PROJECT_NAME}" INTERFACE)
target_link_libraries("${PROJECT_NAME}" INTERFACE "${PROJECT_NAME}-lib")
install(
  TARGETS
  "${PROJECT_NAME}"
  "${PROJECT_NAME}-lib"
  EXPORT
  "${PROJECT_NAME}-targets"
  LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
)
install(
  EXPORT
  "${PROJECT_NAME}-targets"
  NAMESPACE
  "${PROJECT_NAME}::"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)
install(
  DIRECTORY
  "${CMAKE_CURRENT_BINARY_DIR}/include/"
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${module-dir}"
)
# Package license files
install(
  FILES
  "COPYING"
  DESTINATION "${CMAKE_INSTALL_DATADIR}/licenses/${PROJECT_NAME}"
)

# add the testsuite
enable_testing()
add_subdirectory("doc/Examples/sax/features")

=== src/CMakeLists.txt ===

add_subdirectory("sax")
add_subdirectory("dom")
add_subdirectory("xpath")
add_subdirectory("wxml")
add_subdirectory("cml")

set(srcs "${srcs}" PARENT_SCOPE)

=== config/cmake/CMakeLists.txt ===

option(BUILD_SHARED_LIBS "Whether the libraries built should be shared" FALSE)

set(
  module-dir
  "${PROJECT_NAME}/${CMAKE_Fortran_COMPILER_ID}-${CMAKE_Fortran_COMPILER_VERSION}"
)
set(module-dir "${module-dir}" PARENT_SCOPE)

# Set build type as CMake does not provide defaults
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(
    CMAKE_BUILD_TYPE "RelWithDebInfo"
    CACHE STRING "Build type to be used."
    FORCE
  )
  message(
    STATUS
    "Setting build type to '${CMAKE_BUILD_TYPE}' as none was specified."
  )
endif()

include(CMakePackageConfigHelpers)
configure_package_config_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/template.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
  INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)
write_basic_package_version_file(
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
  VERSION "${PROJECT_VERSION}"
  COMPATIBILITY SameMajorVersion
)
install(
  FILES
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/template.pkgconf"
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
  @ONLY
)
install(
  FILES
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
)

=== doc/Tutorial/requirements.txt ===
Sphinx==3.3.1
sphinx-autobuild==2020.9.1
sphinx-inline-tabs
sphinxcontrib-mermaid==0.5.0
sphinx-notfound-page==0.6

sphinx-rtd-theme==0.5.0

# For spelling
sphinxcontrib-spelling==7.0.1
pyenchant==3.1.1

# In March 2023, readthedocs builds were failing due to a jinja2-related error.
# This constraint seems to fix it (for more information see, e.g.,
# https://github.com/readthedocs/readthedocs.org/issues/9037):
jinja2<3.1.0

# In March 2023, with the above combination of requirements, the HTML produced
# by readthedocs was incorrect: many <div> elements (those of hints, notes,
# etc.) were being closed by </aside> instead of </div>. This resulted in
# browsers displaying those elements incorrectly (extending them to the end of
# the page).
# The docutils package introduced <aside> for topics and admonitions in version
# 0.18. Requiring a previous version of docutils seems to fix the issue.
# docutils<0.18
# With docutils 0.17, some ul li elements are missing their symbol (bullet).
# Further reduction of the docutils version constraint fixes this.
docutils==0.16

=== src/cml/CMakeLists.txt ===
set(dir "${CMAKE_CURRENT_SOURCE_DIR}")

list(
  APPEND srcs

  "${dir}/m_wcml.f90"
  "${dir}/m_wstml.f90"
  "${dir}/xmlf90_cml.f90"
)

set(srcs "${srcs}" PARENT_SCOPE)

=== src/dom/CMakeLists.txt ===
set(dir "${CMAKE_CURRENT_SOURCE_DIR}")

list(
  APPEND srcs
  "${dir}/m_dom_attribute.f90"
  "${dir}/m_dom_debug.f90"
  "${dir}/m_dom_document.f90"
  "${dir}/m_dom_element.f90"
  "${dir}/m_dom_error.f90"
  "${dir}/m_dom_namednodemap.f90"
  "${dir}/m_dom_node.f90"
  "${dir}/m_dom_nodelist.f90"
  "${dir}/m_dom_parse.f90"
  "${dir}/m_dom_strings.f90"
  "${dir}/m_dom_types.f90"
  "${dir}/m_dom_utils.f90"
  "${dir}/xmlf90_dom.f90"
)

set(srcs "${srcs}" PARENT_SCOPE)

=== src/sax/CMakeLists.txt ===
set(dir "${CMAKE_CURRENT_SOURCE_DIR}")

list(
  APPEND srcs
  "${dir}/m_sax_buffer.f90"
  "${dir}/m_sax_charset.f90"
  "${dir}/m_sax_converters.f90"
  "${dir}/m_sax_debug.f90"
  "${dir}/m_sax_dictionary.f90"
  "${dir}/m_sax_elstack.f90"
  "${dir}/m_sax_entities.f90"
  "${dir}/m_sax_fsm.f90"
  "${dir}/m_sax_reader.f90"
  "${dir}/m_xml_error.f90"
  "${dir}/m_xml_parser.f90"
  "${dir}/xmlf90_sax.f90"
)

set(srcs "${srcs}" PARENT_SCOPE)

=== src/wxml/CMakeLists.txt ===
set(dir "${CMAKE_CURRENT_SOURCE_DIR}")

list(
  APPEND srcs
  "${dir}/m_wxml_array_str.f90"
  "${dir}/m_wxml_buffer.f90"
  "${dir}/m_wxml_core.f90"
  "${dir}/m_wxml_dictionary.f90"
  "${dir}/m_wxml_elstack.f90"
  "${dir}/m_wxml_error.f90"
  "${dir}/m_wxml_escape.f90"
  "${dir}/m_wxml_overloads.f90"
  "${dir}/m_wxml_text.F90"
  "${dir}/xmlf90_wxml.f90"

)

set(srcs "${srcs}" PARENT_SCOPE)

=== src/xpath/CMakeLists.txt ===
set(dir "${CMAKE_CURRENT_SOURCE_DIR}")

list(
  APPEND srcs

  "${dir}/m_xpath_api.f90"
  "${dir}/match_tester.f90"
  "${dir}/xmlf90_xpath.f90"
)

set(srcs "${srcs}" PARENT_SCOPE)

=== doc/Examples/sax/features/CMakeLists.txt ===
# To avoid Ninja complaints
add_library(lib-handlers OBJECT m_handlers.f90)
target_link_libraries(lib-handlers
  "${PROJECT_NAME}-lib"
)

add_executable(xmlf90-sax-features
  example.F90
)
target_link_libraries(xmlf90-sax-features
  PRIVATE
  "${PROJECT_NAME}-lib"
  lib-handlers
)

add_executable(xmlcheck  xmlcheck.f90)
target_link_libraries(xmlcheck
  PRIVATE
  "${PROJECT_NAME}-lib"
  lib-handlers
)

add_executable(xmlcheck_stat  xmlcheck_stat.f90)
target_link_libraries(xmlcheck_stat
  PRIVATE
  "${PROJECT_NAME}-lib"
  lib-handlers
)

file(MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/install_tests")
file(COPY test.xml DESTINATION "${PROJECT_BINARY_DIR}/install_tests")
file(COPY malformed.xml DESTINATION "${PROJECT_BINARY_DIR}/install_tests")
file(COPY bad_entity.xml DESTINATION "${PROJECT_BINARY_DIR}/install_tests")

#--
add_test(  NAME    XMLF90_SAX_Features
           COMMAND $<TARGET_FILE:xmlf90-sax-features>
	   WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/install_tests"
	)

set_property (TEST XMLF90_SAX_Features
              PROPERTY PASS_REGULAR_EXPRESSION "Mary had a <little> lamb")
set_property (TEST XMLF90_SAX_Features
              PROPERTY FAIL_REGULAR_EXPRESSION "Cannot open file")

#--
add_test(  NAME    XMLF90_SAX_check
           COMMAND $<TARGET_FILE:xmlcheck> test.xml
	   WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/install_tests"
	)
set_property (TEST XMLF90_SAX_check
              PROPERTY PASS_REGULAR_EXPRESSION "Characters processed")
	
#--
add_test(  NAME    XMLF90_SAX_check_stat
           COMMAND $<TARGET_FILE:xmlcheck_stat> test.xml
	   WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/install_tests"
	)
set_property (TEST XMLF90_SAX_check_stat
              PROPERTY PASS_REGULAR_EXPRESSION "Characters processed")
	

#--
add_test(  NAME    XMLF90_SAX_Malformed
           COMMAND $<TARGET_FILE:xmlcheck> malformed.xml
	   WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/install_tests"
	)

set_property (TEST XMLF90_SAX_Malformed
              PROPERTY PASS_REGULAR_EXPRESSION "outside of element")

#--
add_test(  NAME    XMLF90_SAX_Malformed_stat
           COMMAND $<TARGET_FILE:xmlcheck_stat> malformed.xml
	   WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/install_tests"
	)

set_property (TEST XMLF90_SAX_Malformed_stat
              PROPERTY PASS_REGULAR_EXPRESSION "Parsing error")

#--
add_test(  NAME    XMLF90_SAX_BadEntity
           COMMAND $<TARGET_FILE:xmlcheck_stat> bad_entity.xml
	   WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/install_tests"
	)

set_property (TEST XMLF90_SAX_BadEntity
              PROPERTY PASS_REGULAR_EXPRESSION "Parsing error")

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=xmlf90
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=1.6.3
pkgrel=1
pkgdesc="Lightweight XML parser in Fortran. (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://gitlab.com/siesta-project/libraries/xmlf90'
msys2_references=(
  'aur: xmlf90'
)
license=('spdx:BSD-2-Clause')
depends=($([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran"))
makedepends=("${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
source=("https://gitlab.com/siesta-project/libraries/xmlf90/-/archive/${pkgver}/${_realname}-${pkgver}.tar.bz2"
        "001-fix-install-dll.patch")
sha256sums=('5ce60bc798a119e88e29896ce1150370df0564ff0da9e07f8a5efdf9c7f68301'
            '2778c5125365d72c607ddcdd509ae9545946811b399e4999fe41124141ea51ea')

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}

  patch -Np1 -i "${srcdir}"/001-fix-install-dll.patch
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"
}
